/* A Bison parser, made by GNU Bison 2.4.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006,
   2009, 2010 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 31 "policy_parse.y"

#include <sys/types.h>
#include <assert.h>
#include <stdarg.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>

#include <sepol/policydb/expand.h>
#include <sepol/policydb/policydb.h>
#include <sepol/policydb/services.h>
#include <sepol/policydb/conditional.h>
#include <sepol/policydb/flask.h>
#include <sepol/policydb/hierarchy.h>
#include <sepol/policydb/polcaps.h>
#include "queue.h"
#include "checkpolicy.h"
#include "module_compiler.h"
#include "policy_define.h"

extern policydb_t *policydbp;
extern unsigned int pass;

extern char yytext[];
extern int yylex(void);
extern int yywarn(char *msg);
extern int yyerror(char *msg);

typedef int (* require_func_t)();



/* Line 189 of yacc.c  */
#line 110 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     PATH = 258,
     FILENAME = 259,
     CLONE = 260,
     COMMON = 261,
     CLASS = 262,
     CONSTRAIN = 263,
     VALIDATETRANS = 264,
     INHERITS = 265,
     SID = 266,
     ROLE = 267,
     ROLEATTRIBUTE = 268,
     ATTRIBUTE_ROLE = 269,
     ROLES = 270,
     TYPEALIAS = 271,
     TYPEATTRIBUTE = 272,
     TYPEBOUNDS = 273,
     TYPE = 274,
     TYPES = 275,
     ALIAS = 276,
     ATTRIBUTE = 277,
     BOOL = 278,
     IF = 279,
     ELSE = 280,
     TYPE_TRANSITION = 281,
     TYPE_MEMBER = 282,
     TYPE_CHANGE = 283,
     ROLE_TRANSITION = 284,
     RANGE_TRANSITION = 285,
     SENSITIVITY = 286,
     DOMINANCE = 287,
     DOM = 288,
     DOMBY = 289,
     INCOMP = 290,
     CATEGORY = 291,
     LEVEL = 292,
     RANGE = 293,
     MLSCONSTRAIN = 294,
     MLSVALIDATETRANS = 295,
     USER = 296,
     NEVERALLOW = 297,
     ALLOW = 298,
     AUDITALLOW = 299,
     AUDITDENY = 300,
     DONTAUDIT = 301,
     SOURCE = 302,
     TARGET = 303,
     SAMEUSER = 304,
     FSCON = 305,
     PORTCON = 306,
     NETIFCON = 307,
     NODECON = 308,
     PIRQCON = 309,
     IOMEMCON = 310,
     IOPORTCON = 311,
     PCIDEVICECON = 312,
     FSUSEXATTR = 313,
     FSUSETASK = 314,
     FSUSETRANS = 315,
     GENFSCON = 316,
     U1 = 317,
     U2 = 318,
     U3 = 319,
     R1 = 320,
     R2 = 321,
     R3 = 322,
     T1 = 323,
     T2 = 324,
     T3 = 325,
     L1 = 326,
     L2 = 327,
     H1 = 328,
     H2 = 329,
     NOT = 330,
     AND = 331,
     OR = 332,
     XOR = 333,
     CTRUE = 334,
     CFALSE = 335,
     IDENTIFIER = 336,
     NUMBER = 337,
     EQUALS = 338,
     NOTEQUAL = 339,
     IPV4_ADDR = 340,
     IPV6_ADDR = 341,
     MODULE = 342,
     VERSION_IDENTIFIER = 343,
     REQUIRE = 344,
     OPTIONAL = 345,
     POLICYCAP = 346,
     PERMISSIVE = 347,
     FILESYSTEM = 348
   };
#endif
/* Tokens.  */
#define PATH 258
#define FILENAME 259
#define CLONE 260
#define COMMON 261
#define CLASS 262
#define CONSTRAIN 263
#define VALIDATETRANS 264
#define INHERITS 265
#define SID 266
#define ROLE 267
#define ROLEATTRIBUTE 268
#define ATTRIBUTE_ROLE 269
#define ROLES 270
#define TYPEALIAS 271
#define TYPEATTRIBUTE 272
#define TYPEBOUNDS 273
#define TYPE 274
#define TYPES 275
#define ALIAS 276
#define ATTRIBUTE 277
#define BOOL 278
#define IF 279
#define ELSE 280
#define TYPE_TRANSITION 281
#define TYPE_MEMBER 282
#define TYPE_CHANGE 283
#define ROLE_TRANSITION 284
#define RANGE_TRANSITION 285
#define SENSITIVITY 286
#define DOMINANCE 287
#define DOM 288
#define DOMBY 289
#define INCOMP 290
#define CATEGORY 291
#define LEVEL 292
#define RANGE 293
#define MLSCONSTRAIN 294
#define MLSVALIDATETRANS 295
#define USER 296
#define NEVERALLOW 297
#define ALLOW 298
#define AUDITALLOW 299
#define AUDITDENY 300
#define DONTAUDIT 301
#define SOURCE 302
#define TARGET 303
#define SAMEUSER 304
#define FSCON 305
#define PORTCON 306
#define NETIFCON 307
#define NODECON 308
#define PIRQCON 309
#define IOMEMCON 310
#define IOPORTCON 311
#define PCIDEVICECON 312
#define FSUSEXATTR 313
#define FSUSETASK 314
#define FSUSETRANS 315
#define GENFSCON 316
#define U1 317
#define U2 318
#define U3 319
#define R1 320
#define R2 321
#define R3 322
#define T1 323
#define T2 324
#define T3 325
#define L1 326
#define L2 327
#define H1 328
#define H2 329
#define NOT 330
#define AND 331
#define OR 332
#define XOR 333
#define CTRUE 334
#define CFALSE 335
#define IDENTIFIER 336
#define NUMBER 337
#define EQUALS 338
#define NOTEQUAL 339
#define IPV4_ADDR 340
#define IPV6_ADDR 341
#define MODULE 342
#define VERSION_IDENTIFIER 343
#define REQUIRE 344
#define OPTIONAL 345
#define POLICYCAP 346
#define PERMISSIVE 347
#define FILESYSTEM 348




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 68 "policy_parse.y"

	unsigned int val;
	uintptr_t valptr;
	void *ptr;
        require_func_t require_func;



/* Line 214 of yacc.c  */
#line 341 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 353 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  9
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   989

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  105
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  171
/* YYNRULES -- Number of rules.  */
#define YYNRULES  346
/* YYNRULES -- Number of states.  */
#define YYNSTATES  689

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   348

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   101,     2,     2,     2,     2,     2,
      99,   100,   104,     2,    98,   102,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    97,    96,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    94,     2,    95,   103,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,     8,     9,    10,    27,    29,
      32,    35,    37,    40,    43,    46,    48,    49,    51,    54,
      60,    62,    65,    71,    76,    84,    86,    87,    93,    95,
      98,   103,   107,   110,   113,   118,   120,   121,   123,   126,
     131,   135,   137,   140,   146,   150,   152,   155,   157,   159,
     165,   170,   172,   175,   177,   179,   181,   183,   185,   187,
     189,   191,   193,   195,   197,   199,   201,   203,   205,   207,
     209,   211,   213,   215,   217,   219,   221,   225,   231,   236,
     241,   246,   251,   254,   255,   260,   262,   264,   271,   276,
     277,   281,   284,   288,   292,   296,   300,   304,   306,   308,
     311,   312,   314,   316,   318,   329,   337,   345,   353,   355,
     357,   359,   361,   369,   377,   385,   393,   404,   412,   420,
     428,   434,   442,   444,   446,   448,   450,   452,   460,   468,
     476,   484,   492,   496,   502,   507,   512,   518,   526,   531,
     533,   536,   540,   546,   551,   553,   554,   556,   559,   561,
     563,   569,   574,   578,   581,   585,   589,   591,   595,   599,
     603,   604,   609,   610,   615,   616,   621,   622,   627,   628,
     633,   634,   639,   640,   645,   646,   651,   652,   657,   659,
     660,   665,   666,   671,   674,   675,   680,   681,   686,   690,
     694,   698,   702,   706,   710,   712,   714,   716,   718,   720,
     722,   724,   727,   734,   739,   740,   742,   745,   749,   751,
     752,   754,   757,   759,   761,   763,   765,   769,   773,   779,
     783,   789,   793,   795,   796,   798,   801,   807,   811,   813,
     814,   816,   819,   824,   831,   833,   834,   836,   839,   844,
     846,   847,   849,   852,   857,   862,   864,   865,   867,   870,
     875,   880,   885,   887,   888,   890,   893,   900,   901,   909,
     914,   916,   923,   926,   927,   931,   933,   937,   939,   941,
     945,   947,   949,   951,   953,   955,   958,   961,   962,   967,
     969,   971,   973,   977,   979,   982,   987,   989,   992,   994,
     996,   999,  1003,  1005,  1008,  1010,  1011,  1015,  1017,  1019,
    1021,  1023,  1025,  1027,  1029,  1031,  1033,  1035,  1039,  1043,
    1046,  1051,  1053,  1055,  1057,  1060,  1063,  1065,  1067,  1069,
    1071,  1073,  1075,  1077,  1082,  1085,  1087,  1090,  1094,  1098,
    1100,  1102,  1104,  1106,  1108,  1110,  1112,  1114,  1116,  1120,
    1121,  1128,  1133,  1134,  1136,  1138,  1141
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     106,     0,    -1,   107,    -1,   258,    -1,    -1,    -1,    -1,
     108,   111,   113,   115,   109,   121,   136,   199,   177,   110,
     202,   211,   224,   227,   214,   204,    -1,   112,    -1,   111,
     112,    -1,     7,   251,    -1,   114,    -1,   113,   114,    -1,
      11,   251,    -1,   116,   119,    -1,   117,    -1,    -1,   118,
      -1,   117,   118,    -1,     6,   251,    94,   246,    95,    -1,
     120,    -1,   119,   120,    -1,     7,   251,    94,   246,    95,
      -1,     7,   251,    10,   251,    -1,     7,   251,    10,   251,
      94,   246,    95,    -1,   122,    -1,    -1,   123,   126,   127,
     130,   132,    -1,   124,    -1,   123,   124,    -1,    31,   251,
     125,    96,    -1,    31,   251,    96,    -1,    21,   239,    -1,
      32,   251,    -1,    32,    94,   246,    95,    -1,   128,    -1,
      -1,   129,    -1,   128,   129,    -1,    36,   251,   125,    96,
      -1,    36,   251,    96,    -1,   131,    -1,   130,   131,    -1,
      37,   251,    97,   236,    96,    -1,    37,   251,    96,    -1,
     133,    -1,   132,   133,    -1,   134,    -1,   135,    -1,    39,
     239,   239,   182,    96,    -1,    40,   239,   182,    96,    -1,
     137,    -1,   136,   137,    -1,   139,    -1,   138,    -1,   148,
      -1,   270,    -1,   256,    -1,    96,    -1,   168,    -1,   169,
      -1,   171,    -1,   172,    -1,   173,    -1,   176,    -1,   170,
      -1,   140,    -1,   141,    -1,   142,    -1,   143,    -1,   144,
      -1,   146,    -1,   160,    -1,   161,    -1,   162,    -1,   257,
      -1,    22,   251,    96,    -1,    19,   251,   125,   145,    96,
      -1,    19,   251,   145,    96,    -1,    16,   251,   125,    96,
      -1,    17,   251,   236,    96,    -1,    18,   251,   236,    96,
      -1,    98,   236,    -1,    -1,    23,   251,   147,    96,    -1,
      79,    -1,    80,    -1,    24,   150,    94,   152,    95,   149,
      -1,    25,    94,   152,    95,    -1,    -1,    99,   150,   100,
      -1,    75,   150,    -1,   150,    76,   150,    -1,   150,    77,
     150,    -1,   150,    78,   150,    -1,   150,    83,   150,    -1,
     150,    84,   150,    -1,   151,    -1,   251,    -1,   152,   153,
      -1,    -1,   154,    -1,   155,    -1,   264,    -1,    26,   239,
     239,    97,   239,   251,   101,   253,   101,    96,    -1,    26,
     239,   239,    97,   239,   251,    96,    -1,    27,   239,   239,
      97,   239,   251,    96,    -1,    28,   239,   239,    97,   239,
     251,    96,    -1,   156,    -1,   157,    -1,   158,    -1,   159,
      -1,    43,   239,   239,    97,   239,   239,    96,    -1,    44,
     239,   239,    97,   239,   239,    96,    -1,    45,   239,   239,
      97,   239,   239,    96,    -1,    46,   239,   239,    97,   239,
     239,    96,    -1,    26,   239,   239,    97,   239,   251,   101,
     253,   101,    96,    -1,    26,   239,   239,    97,   239,   251,
      96,    -1,    27,   239,   239,    97,   239,   251,    96,    -1,
      28,   239,   239,    97,   239,   251,    96,    -1,    30,   239,
     239,   234,    96,    -1,    30,   239,   239,    97,   239,   234,
      96,    -1,   163,    -1,   164,    -1,   165,    -1,   166,    -1,
     167,    -1,    43,   239,   239,    97,   239,   239,    96,    -1,
      44,   239,   239,    97,   239,   239,    96,    -1,    45,   239,
     239,    97,   239,   239,    96,    -1,    46,   239,   239,    97,
     239,   239,    96,    -1,    42,   239,   239,    97,   239,   239,
      96,    -1,    14,   251,    96,    -1,    12,   251,    20,   239,
      96,    -1,    12,   251,   145,    96,    -1,    32,    94,   174,
      95,    -1,    29,   239,   239,   251,    96,    -1,    29,   239,
     239,    97,   239,   251,    96,    -1,    43,   239,   239,    96,
      -1,   175,    -1,   174,   175,    -1,    12,   245,    96,    -1,
      12,   245,    94,   174,    95,    -1,    13,   251,   236,    96,
      -1,   178,    -1,    -1,   179,    -1,   178,   179,    -1,   180,
      -1,   181,    -1,     8,   239,   239,   182,    96,    -1,     9,
     239,   182,    96,    -1,    99,   182,   100,    -1,    75,   182,
      -1,   182,    76,   182,    -1,   182,    77,   182,    -1,   183,
      -1,    62,   197,    63,    -1,    65,   198,    66,    -1,    68,
     197,    69,    -1,    -1,    62,   197,   184,   243,    -1,    -1,
      63,   197,   185,   243,    -1,    -1,    64,   197,   186,   243,
      -1,    -1,    65,   197,   187,   243,    -1,    -1,    66,   197,
     188,   243,    -1,    -1,    67,   197,   189,   243,    -1,    -1,
      68,   197,   190,   243,    -1,    -1,    69,   197,   191,   243,
      -1,    -1,    70,   197,   192,   243,    -1,    49,    -1,    -1,
      47,    12,   193,   243,    -1,    -1,    48,    12,   194,   243,
      -1,    12,   198,    -1,    -1,    47,    19,   195,   243,    -1,
      -1,    48,    19,   196,   243,    -1,    71,   198,    72,    -1,
      71,   198,    74,    -1,    73,   198,    72,    -1,    73,   198,
      74,    -1,    71,   198,    73,    -1,    72,   198,    74,    -1,
      83,    -1,    84,    -1,   197,    -1,    33,    -1,    34,    -1,
      35,    -1,   200,    -1,   199,   200,    -1,    41,   251,    15,
     239,   201,    96,    -1,    37,   235,    38,   234,    -1,    -1,
     203,    -1,   202,   203,    -1,    11,   251,   232,    -1,   205,
      -1,    -1,   206,    -1,   205,   206,    -1,   207,    -1,   208,
      -1,   209,    -1,   210,    -1,    54,   254,   232,    -1,    55,
     254,   232,    -1,    55,   254,   102,   254,   232,    -1,    56,
     254,   232,    -1,    56,   254,   102,   254,   232,    -1,    57,
     254,   232,    -1,   212,    -1,    -1,   213,    -1,   212,   213,
      -1,    50,   254,   254,   232,   232,    -1,   215,   218,   221,
      -1,   216,    -1,    -1,   217,    -1,   216,   217,    -1,    51,
     251,   254,   232,    -1,    51,   251,   254,   102,   254,   232,
      -1,   219,    -1,    -1,   220,    -1,   219,   220,    -1,    52,
     251,   232,   232,    -1,   222,    -1,    -1,   223,    -1,   222,
     223,    -1,    53,   231,   231,   232,    -1,    53,   255,   255,
     232,    -1,   225,    -1,    -1,   226,    -1,   225,   226,    -1,
      58,   253,   232,    96,    -1,    59,   251,   232,    96,    -1,
      60,   251,   232,    96,    -1,   228,    -1,    -1,   229,    -1,
     228,   229,    -1,    61,   253,   252,   102,   251,   232,    -1,
      -1,    61,   253,   252,   102,   102,   230,   232,    -1,    61,
     253,   252,   232,    -1,    85,    -1,   251,    97,   251,    97,
     251,   233,    -1,    97,   234,    -1,    -1,   235,   102,   235,
      -1,   235,    -1,   251,    97,   236,    -1,   251,    -1,   251,
      -1,   236,    98,   251,    -1,   103,    -1,   104,    -1,   251,
      -1,   247,    -1,   238,    -1,   237,   251,    -1,   237,   247,
      -1,    -1,   251,   102,   240,   251,    -1,   237,    -1,   238,
      -1,   245,    -1,    94,   244,    95,    -1,   242,    -1,   241,
     245,    -1,   241,    94,   244,    95,    -1,   245,    -1,   244,
     245,    -1,    81,    -1,   251,    -1,   246,   251,    -1,    94,
     248,    95,    -1,   249,    -1,   248,   249,    -1,   251,    -1,
      -1,   102,   250,   251,    -1,   247,    -1,    81,    -1,     3,
      -1,     4,    -1,    82,    -1,    85,    -1,    88,    -1,    81,
      -1,    82,    -1,    86,    -1,    91,   251,    96,    -1,    92,
     251,    96,    -1,   259,   261,    -1,    87,   251,   260,    96,
      -1,    88,    -1,   254,    -1,   231,    -1,   262,   275,    -1,
     262,   263,    -1,   263,    -1,   138,    -1,   139,    -1,   148,
      -1,   264,    -1,   270,    -1,    96,    -1,    89,    94,   265,
      95,    -1,   265,   266,    -1,   266,    -1,   267,    96,    -1,
     268,   269,    96,    -1,     7,   251,   239,    -1,    12,    -1,
      19,    -1,    22,    -1,    14,    -1,    41,    -1,    23,    -1,
      31,    -1,    36,    -1,   251,    -1,   269,    98,   251,    -1,
      -1,   273,    94,   261,    95,   271,   272,    -1,   274,    94,
     261,    95,    -1,    -1,    90,    -1,    25,    -1,   200,   275,
      -1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   152,   152,   153,   155,   157,   160,   155,   164,   165,
     167,   170,   171,   173,   176,   178,   179,   181,   182,   184,
     187,   188,   190,   192,   194,   197,   198,   200,   202,   203,
     205,   207,   210,   212,   214,   217,   218,   220,   221,   223,
     225,   228,   229,   231,   233,   236,   237,   239,   240,   242,
     245,   248,   249,   251,   252,   253,   254,   255,   256,   258,
     259,   260,   261,   262,   263,   264,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   277,   280,   282,   285,
     288,   291,   294,   295,   297,   300,   302,   305,   308,   311,
     312,   314,   317,   320,   323,   326,   329,   332,   335,   339,
     342,   344,   346,   348,   351,   354,   357,   360,   364,   366,
     368,   370,   373,   377,   381,   385,   389,   391,   393,   395,
     398,   400,   403,   404,   405,   406,   407,   409,   412,   415,
     418,   421,   424,   427,   430,   433,   435,   437,   440,   443,
     445,   448,   450,   453,   456,   457,   459,   460,   462,   463,
     465,   468,   471,   473,   476,   479,   482,   485,   488,   491,
     494,   494,   497,   497,   500,   500,   503,   503,   506,   506,
     509,   509,   512,   512,   515,   515,   518,   518,   521,   524,
     524,   527,   527,   530,   533,   533,   536,   536,   539,   542,
     545,   548,   551,   554,   558,   560,   563,   565,   567,   569,
     572,   573,   575,   578,   579,   581,   582,   584,   587,   587,
     589,   590,   592,   593,   594,   595,   597,   600,   602,   605,
     607,   610,   613,   614,   616,   617,   619,   622,   624,   625,
     627,   628,   630,   632,   635,   636,   638,   639,   641,   644,
     645,   647,   648,   650,   652,   655,   656,   658,   659,   661,
     663,   665,   668,   669,   671,   672,   674,   676,   676,   678,
     681,   684,   686,   687,   689,   691,   694,   696,   699,   700,
     702,   704,   706,   708,   710,   713,   716,   719,   719,   722,
     725,   728,   729,   730,   731,   732,   734,   735,   737,   740,
     741,   743,   745,   745,   747,   747,   747,   747,   749,   752,
     755,   757,   759,   761,   763,   766,   769,   772,   775,   780,
     785,   788,   790,   792,   794,   796,   797,   799,   800,   801,
     802,   803,   804,   806,   808,   809,   811,   812,   814,   817,
     818,   819,   820,   821,   822,   823,   824,   826,   828,   832,
     831,   836,   838,   840,   843,   846,   847
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "PATH", "FILENAME", "CLONE", "COMMON",
  "CLASS", "CONSTRAIN", "VALIDATETRANS", "INHERITS", "SID", "ROLE",
  "ROLEATTRIBUTE", "ATTRIBUTE_ROLE", "ROLES", "TYPEALIAS", "TYPEATTRIBUTE",
  "TYPEBOUNDS", "TYPE", "TYPES", "ALIAS", "ATTRIBUTE", "BOOL", "IF",
  "ELSE", "TYPE_TRANSITION", "TYPE_MEMBER", "TYPE_CHANGE",
  "ROLE_TRANSITION", "RANGE_TRANSITION", "SENSITIVITY", "DOMINANCE", "DOM",
  "DOMBY", "INCOMP", "CATEGORY", "LEVEL", "RANGE", "MLSCONSTRAIN",
  "MLSVALIDATETRANS", "USER", "NEVERALLOW", "ALLOW", "AUDITALLOW",
  "AUDITDENY", "DONTAUDIT", "SOURCE", "TARGET", "SAMEUSER", "FSCON",
  "PORTCON", "NETIFCON", "NODECON", "PIRQCON", "IOMEMCON", "IOPORTCON",
  "PCIDEVICECON", "FSUSEXATTR", "FSUSETASK", "FSUSETRANS", "GENFSCON",
  "U1", "U2", "U3", "R1", "R2", "R3", "T1", "T2", "T3", "L1", "L2", "H1",
  "H2", "NOT", "AND", "OR", "XOR", "CTRUE", "CFALSE", "IDENTIFIER",
  "NUMBER", "EQUALS", "NOTEQUAL", "IPV4_ADDR", "IPV6_ADDR", "MODULE",
  "VERSION_IDENTIFIER", "REQUIRE", "OPTIONAL", "POLICYCAP", "PERMISSIVE",
  "FILESYSTEM", "'{'", "'}'", "';'", "':'", "','", "'('", "')'", "'\"'",
  "'-'", "'~'", "'*'", "$accept", "policy", "base_policy", "$@1", "$@2",
  "$@3", "classes", "class_def", "initial_sids", "initial_sid_def",
  "access_vectors", "opt_common_perms", "common_perms", "common_perms_def",
  "av_perms", "av_perms_def", "opt_mls", "mls", "sensitivities",
  "sensitivity_def", "alias_def", "dominance", "opt_categories",
  "categories", "category_def", "levels", "level_def", "mlspolicy",
  "mlspolicy_decl", "mlsconstraint_def", "mlsvalidatetrans_def", "te_rbac",
  "te_rbac_decl", "rbac_decl", "te_decl", "attribute_def", "type_def",
  "typealias_def", "typeattribute_def", "typebounds_def", "opt_attr_list",
  "bool_def", "bool_val", "cond_stmt_def", "cond_else", "cond_expr",
  "cond_expr_prim", "cond_pol_list", "cond_rule_def",
  "cond_transition_def", "cond_te_avtab_def", "cond_allow_def",
  "cond_auditallow_def", "cond_auditdeny_def", "cond_dontaudit_def",
  "transition_def", "range_trans_def", "te_avtab_def", "allow_def",
  "auditallow_def", "auditdeny_def", "dontaudit_def", "neverallow_def",
  "attribute_role_def", "role_type_def", "role_attr_def", "role_dominance",
  "role_trans_def", "role_allow_def", "roles", "role_def",
  "roleattribute_def", "opt_constraints", "constraints", "constraint_decl",
  "constraint_def", "validatetrans_def", "cexpr", "cexpr_prim", "$@4",
  "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12", "$@13",
  "$@14", "$@15", "$@16", "op", "role_mls_op", "users", "user_def",
  "opt_mls_user", "initial_sid_contexts", "initial_sid_context_def",
  "opt_dev_contexts", "dev_contexts", "dev_context_def",
  "pirq_context_def", "iomem_context_def", "ioport_context_def",
  "pci_context_def", "opt_fs_contexts", "fs_contexts", "fs_context_def",
  "net_contexts", "opt_port_contexts", "port_contexts", "port_context_def",
  "opt_netif_contexts", "netif_contexts", "netif_context_def",
  "opt_node_contexts", "node_contexts", "node_context_def", "opt_fs_uses",
  "fs_uses", "fs_use_def", "opt_genfs_contexts", "genfs_contexts",
  "genfs_context_def", "$@17", "ipv4_addr_def", "security_context_def",
  "opt_mls_range_def", "mls_range_def", "mls_level_def", "id_comma_list",
  "tilde", "asterisk", "names", "$@18", "tilde_push", "asterisk_push",
  "names_push", "identifier_list_push", "identifier_push",
  "identifier_list", "nested_id_set", "nested_id_list",
  "nested_id_element", "$@19", "identifier", "path", "filename", "number",
  "ipv6_addr", "policycap_def", "permissive_def", "module_policy",
  "module_def", "version_identifier", "avrules_block", "avrule_decls",
  "avrule_decl", "require_block", "require_list", "require_decl",
  "require_class", "require_decl_def", "require_id_list", "optional_block",
  "$@20", "optional_else", "optional_decl", "else_decl",
  "avrule_user_defs", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   123,   125,    59,    58,    44,    40,
      41,    34,    45,   126,    42
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   105,   106,   106,   108,   109,   110,   107,   111,   111,
     112,   113,   113,   114,   115,   116,   116,   117,   117,   118,
     119,   119,   120,   120,   120,   121,   121,   122,   123,   123,
     124,   124,   125,   126,   126,   127,   127,   128,   128,   129,
     129,   130,   130,   131,   131,   132,   132,   133,   133,   134,
     135,   136,   136,   137,   137,   137,   137,   137,   137,   138,
     138,   138,   138,   138,   138,   138,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   140,   141,   141,   142,
     143,   144,   145,   145,   146,   147,   147,   148,   149,   149,
     150,   150,   150,   150,   150,   150,   150,   150,   151,   152,
     152,   153,   153,   153,   154,   154,   154,   154,   155,   155,
     155,   155,   156,   157,   158,   159,   160,   160,   160,   160,
     161,   161,   162,   162,   162,   162,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   172,   173,   174,
     174,   175,   175,   176,   177,   177,   178,   178,   179,   179,
     180,   181,   182,   182,   182,   182,   182,   183,   183,   183,
     184,   183,   185,   183,   186,   183,   187,   183,   188,   183,
     189,   183,   190,   183,   191,   183,   192,   183,   183,   193,
     183,   194,   183,   183,   195,   183,   196,   183,   183,   183,
     183,   183,   183,   183,   197,   197,   198,   198,   198,   198,
     199,   199,   200,   201,   201,   202,   202,   203,   204,   204,
     205,   205,   206,   206,   206,   206,   207,   208,   208,   209,
     209,   210,   211,   211,   212,   212,   213,   214,   215,   215,
     216,   216,   217,   217,   218,   218,   219,   219,   220,   221,
     221,   222,   222,   223,   223,   224,   224,   225,   225,   226,
     226,   226,   227,   227,   228,   228,   229,   230,   229,   229,
     231,   232,   233,   233,   234,   234,   235,   235,   236,   236,
     237,   238,   239,   239,   239,   239,   239,   240,   239,   241,
     242,   243,   243,   243,   243,   243,   244,   244,   245,   246,
     246,   247,   248,   248,   249,   250,   249,   249,   251,   252,
     253,   253,   253,   253,   253,   254,   255,   256,   257,   258,
     259,   260,   260,   260,   261,   262,   262,   263,   263,   263,
     263,   263,   263,   264,   265,   265,   266,   266,   267,   268,
     268,   268,   268,   268,   268,   268,   268,   269,   269,   271,
     270,   272,   272,   273,   274,   275,   275
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     0,     0,     0,    16,     1,     2,
       2,     1,     2,     2,     2,     1,     0,     1,     2,     5,
       1,     2,     5,     4,     7,     1,     0,     5,     1,     2,
       4,     3,     2,     2,     4,     1,     0,     1,     2,     4,
       3,     1,     2,     5,     3,     1,     2,     1,     1,     5,
       4,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     5,     4,     4,
       4,     4,     2,     0,     4,     1,     1,     6,     4,     0,
       3,     2,     3,     3,     3,     3,     3,     1,     1,     2,
       0,     1,     1,     1,    10,     7,     7,     7,     1,     1,
       1,     1,     7,     7,     7,     7,    10,     7,     7,     7,
       5,     7,     1,     1,     1,     1,     1,     7,     7,     7,
       7,     7,     3,     5,     4,     4,     5,     7,     4,     1,
       2,     3,     5,     4,     1,     0,     1,     2,     1,     1,
       5,     4,     3,     2,     3,     3,     1,     3,     3,     3,
       0,     4,     0,     4,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     4,     0,     4,     0,     4,     1,     0,
       4,     0,     4,     2,     0,     4,     0,     4,     3,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     2,     6,     4,     0,     1,     2,     3,     1,     0,
       1,     2,     1,     1,     1,     1,     3,     3,     5,     3,
       5,     3,     1,     0,     1,     2,     5,     3,     1,     0,
       1,     2,     4,     6,     1,     0,     1,     2,     4,     1,
       0,     1,     2,     4,     4,     1,     0,     1,     2,     4,
       4,     4,     1,     0,     1,     2,     6,     0,     7,     4,
       1,     6,     2,     0,     3,     1,     3,     1,     1,     3,
       1,     1,     1,     1,     1,     2,     2,     0,     4,     1,
       1,     1,     3,     1,     2,     4,     1,     2,     1,     1,
       2,     3,     1,     2,     1,     0,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     2,
       4,     1,     1,     1,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     4,     2,     1,     2,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     0,
       6,     4,     0,     1,     1,     2,     0
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     2,     0,     3,     0,   298,     0,     1,
       0,     0,     8,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   343,     0,   322,   317,   318,
      66,    67,    68,    69,    70,    71,   319,    72,    73,    74,
     122,   123,   124,   125,   126,    59,    60,    65,    61,    62,
      63,    64,    75,   309,   346,   316,   320,   321,     0,   305,
     260,   311,   313,   312,     0,    10,     0,     9,    16,    11,
      83,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,     0,    97,    98,     0,   270,   271,     0,   274,     0,
     273,   272,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   346,   315,   314,     0,   310,
      13,     0,    12,     5,     0,    15,    17,     0,     0,     0,
       0,   268,   132,     0,     0,     0,     0,    83,     0,    76,
      85,    86,     0,    91,     0,     0,     0,     0,     0,     0,
     100,   295,   297,     0,   292,   294,   276,   275,     0,   277,
       0,     0,     0,     0,     0,     0,   139,     0,     0,     0,
       0,     0,     0,   329,   332,   330,   331,   334,   335,   336,
     333,     0,   325,     0,     0,   308,     0,   345,     0,     0,
      26,     0,    14,    20,    18,     0,    82,   134,   143,     0,
      32,    79,    80,    81,     0,    78,    84,    90,    92,    93,
      94,    95,    96,     0,     0,   291,   293,     0,     0,     0,
       0,     0,     0,     0,     0,   265,   267,   288,     0,   135,
     140,     0,   138,     0,     0,     0,     0,     0,   323,   324,
     326,   337,     0,     0,   339,     0,     0,     0,    25,     0,
      28,     0,    21,   133,   269,    77,     0,     0,     0,     0,
       0,     0,     0,    89,    99,   101,   102,   108,   109,   110,
     111,   103,   296,     0,   278,     0,     0,     0,   136,     0,
     120,     0,     0,     0,   141,     0,     0,     0,     0,     0,
     328,   327,     0,   204,   342,     0,   289,     0,     0,    58,
       0,    51,    54,    53,    55,    57,    56,     0,    29,    36,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      87,     0,     0,     0,     0,     0,   264,   266,     0,     0,
       0,     0,     0,     0,   338,     0,     0,   344,   340,     0,
      19,   290,    31,     0,     0,    52,   145,   200,     0,    33,
       0,     0,    35,    37,    23,     0,     0,     0,     0,     0,
       0,     0,     0,   100,   117,     0,   118,   119,   137,   121,
     142,   131,   127,   128,   129,   130,     0,   202,     0,    30,
     307,     0,     0,     6,   144,   146,   148,   149,   201,     0,
       0,     0,     0,    41,    38,     0,    22,     0,     0,     0,
       0,     0,     0,     0,     0,   300,   304,   301,   302,   303,
       0,     0,     0,     0,     0,     0,   147,    34,    40,     0,
       0,     0,     0,    42,    27,    45,    47,    48,     0,     0,
       0,     0,     0,     0,     0,     0,    88,     0,   203,   341,
       0,     0,     0,     0,   178,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     156,     0,   223,   205,    39,    44,     0,     0,     0,    46,
      24,     0,     0,     0,     0,     0,     0,     0,   116,     0,
     197,   198,   199,   194,   195,   196,   183,   179,   184,   181,
     186,   160,   162,   164,   166,     0,   168,   170,   172,   174,
     176,     0,     0,     0,   153,     0,     0,     0,   151,     0,
       0,   206,   246,   222,   224,     0,     0,     0,   105,     0,
     106,   107,   112,   113,   114,   115,   150,     0,     0,     0,
       0,   157,     0,     0,     0,     0,   158,     0,     0,   159,
       0,     0,     0,   188,   192,   189,   193,   190,   191,   152,
     154,   155,   207,     0,     0,     0,     0,     0,   253,   245,
     247,   225,    43,     0,    50,     0,     0,   279,   280,     0,
     283,   180,   281,   185,   182,   187,   161,   163,   165,   167,
     169,   171,   173,   175,   177,     0,     0,     0,     0,     0,
       0,   229,   252,   254,   248,    49,     0,     0,   286,     0,
     284,     0,     0,     0,     0,     0,     0,     0,   209,   235,
     228,   230,   255,   104,   282,   287,     0,     0,   226,   249,
     250,   251,   299,     0,     0,     0,     0,     0,     0,     7,
     208,   210,   212,   213,   214,   215,     0,   240,   234,   236,
     231,   285,   263,     0,   259,     0,     0,     0,     0,     0,
     211,     0,     0,   227,   239,   241,   237,     0,   261,   257,
       0,     0,   232,   216,     0,   217,     0,   219,   221,     0,
     306,     0,     0,   242,   262,     0,   256,     0,     0,     0,
     238,     0,     0,   258,   233,   218,   220,   243,   244
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,     4,   190,   415,    11,    12,    78,    79,
     123,   124,   125,   126,   192,   193,   247,   248,   249,   250,
     134,   309,   351,   352,   353,   392,   393,   424,   425,   426,
     427,   300,   301,    38,    39,    40,    41,    42,    43,    44,
     129,    45,   142,    46,   320,    91,    92,   213,   264,   265,
     266,   267,   268,   269,   270,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,   165,
     166,    61,   383,   384,   385,   386,   387,   459,   460,   532,
     533,   534,   535,   537,   538,   540,   541,   542,   527,   529,
     528,   530,   485,   486,   346,   115,   336,   462,   463,   629,
     630,   631,   632,   633,   634,   635,   512,   513,   514,   608,
     609,   610,   611,   637,   638,   639,   653,   654,   655,   558,
     559,   560,   591,   592,   593,   675,    72,   552,   658,   224,
     225,   130,    97,    98,    99,   218,   569,   570,   571,   597,
     572,   295,   100,   153,   154,   214,   101,   623,   410,    73,
     672,   305,    62,     5,     6,    74,    63,    64,    65,    66,
     181,   182,   183,   184,   242,    67,   294,   338,    68,   339,
     117
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -604
static const yytype_int16 yypact[] =
{
     -53,   -38,   151,  -604,    45,  -604,   812,  -604,   179,  -604,
     -38,   235,  -604,   -38,   -38,   -38,   -38,   -38,   -38,   -38,
     -38,   -38,   -25,    30,    30,    30,    30,    30,    66,    30,
      30,    30,    30,    30,    99,  -604,   -38,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,   501,  -604,  -604,  -604,   105,  -604,
    -604,  -604,  -604,  -604,   125,  -604,   -38,  -604,   144,  -604,
       7,   -38,   170,   252,   -38,   -38,     9,   200,   210,   -25,
     -25,   209,  -604,  -604,    82,  -604,  -604,   115,  -604,    30,
    -604,   202,    30,    30,    30,    30,   300,    30,    30,    30,
      30,    30,   321,   246,   -38,   326,  -604,  -604,   812,  -604,
    -604,   -38,  -604,  -604,   341,   377,  -604,    30,   -38,   302,
      25,  -604,  -604,    30,   319,   181,   229,   322,   337,  -604,
    -604,  -604,   339,   272,   128,   -25,   -25,   -25,   -25,   -25,
    -604,  -604,  -604,   -24,  -604,  -604,  -604,  -604,   355,  -604,
     362,   366,   110,   111,   342,    13,  -604,   367,   278,   369,
     370,   371,   -38,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,    17,  -604,   374,   -38,  -604,   443,  -604,   378,   375,
     440,   -38,   341,  -604,  -604,   379,   380,  -604,  -604,   -38,
    -604,  -604,  -604,  -604,   381,  -604,  -604,  -604,   272,   253,
     262,  -604,  -604,   142,   -38,  -604,  -604,    30,   -38,    30,
      30,    30,   383,    30,   384,   372,   385,  -604,   236,  -604,
    -604,    30,  -604,    30,    30,    30,    30,    30,  -604,  -604,
    -604,  -604,   243,    30,  -604,   -38,   -38,   893,  -604,   361,
    -604,     1,  -604,  -604,  -604,  -604,    30,    30,    30,    30,
      30,    30,    30,   447,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,   -38,  -604,   -38,   -38,   -38,  -604,   -38,
    -604,   -38,   -38,   300,  -604,    30,    30,    30,    30,    30,
    -604,  -604,   -38,   439,   456,   159,  -604,    20,   -38,  -604,
     716,  -604,  -604,  -604,  -604,  -604,  -604,   149,  -604,   448,
     -38,   -38,    30,    30,    30,    30,    30,    30,    30,   389,
    -604,    57,   390,   391,   397,   403,  -604,   380,    14,   404,
     405,   406,   407,   408,  -604,   -38,   409,  -604,  -604,   394,
    -604,  -604,  -604,   410,   411,  -604,    53,  -604,   -38,  -604,
     -38,   472,   448,  -604,   416,   167,   388,   414,   419,   424,
     425,   429,   435,  -604,  -604,    18,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,   474,  -604,   812,  -604,
    -604,    30,    30,  -604,   423,  -604,  -604,  -604,  -604,   187,
      21,   -38,   268,  -604,  -604,   -38,  -604,    30,    30,    30,
      30,    30,    30,    30,   206,  -604,  -604,  -604,  -604,  -604,
     433,   -38,   441,    30,   251,   524,  -604,  -604,  -604,   442,
     354,    30,    30,  -604,   415,  -604,  -604,  -604,   188,   -38,
     -38,   -38,    30,    30,    30,    30,  -604,   444,  -604,  -604,
     251,    31,    67,   137,  -604,   373,   373,   373,    31,   373,
     373,   373,   373,   373,    31,    31,    31,   251,   251,   118,
    -604,   -38,    52,  -604,  -604,  -604,   -38,    30,   251,  -604,
    -604,   140,   445,   452,   453,   454,   455,   457,  -604,   126,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,   476,  -604,  -604,   471,   486,  -604,  -604,   485,  -604,
    -604,   307,   483,   279,  -604,    42,   251,   251,  -604,   -38,
     477,  -604,   327,   508,  -604,   293,   251,   139,  -604,    18,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,    78,    78,    78,
      78,  -604,    78,    78,    78,    78,  -604,    78,    78,  -604,
      78,    78,    78,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,   484,  -604,   464,   477,    18,   -38,   -38,   502,   327,
    -604,  -604,  -604,   143,  -604,   461,   342,  -604,  -604,   177,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,   -38,   -38,   -38,   -38,   -38,
      18,   514,   502,  -604,  -604,  -604,   470,   189,  -604,   342,
    -604,   480,   -38,   475,   482,   487,   576,   -38,   392,   528,
     514,  -604,  -604,  -604,  -604,  -604,   207,   -38,  -604,  -604,
    -604,  -604,  -604,   -21,   477,   477,   477,   477,   477,  -604,
     392,  -604,  -604,  -604,  -604,  -604,   -38,   529,   528,  -604,
    -604,  -604,   492,    41,  -604,    73,   -38,    76,   108,   -38,
    -604,   -38,   376,  -604,   529,  -604,  -604,   -38,  -604,  -604,
     -38,   477,  -604,  -604,   477,  -604,   477,  -604,  -604,   -38,
    -604,   496,   509,  -604,  -604,   -38,  -604,   -38,   -38,   -38,
    -604,   -38,   -38,  -604,  -604,  -604,  -604,  -604,  -604
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -604,  -604,  -604,  -604,  -604,  -604,  -604,   583,  -604,   518,
    -604,  -604,  -604,   478,  -604,   412,  -604,  -604,  -604,   350,
     -79,  -604,  -604,  -604,   248,  -604,   213,  -604,   178,  -604,
    -604,  -604,   308,  -215,  -210,  -604,  -604,  -604,  -604,  -604,
     -39,  -604,  -604,  -209,  -604,   -17,  -604,   244,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,   328,
    -155,  -604,  -604,  -604,   225,  -604,  -604,  -381,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,    -8,   -78,  -604,  -245,  -604,  -604,   148,  -604,
    -604,   -18,  -604,  -604,  -604,  -604,  -604,  -604,   100,  -604,
    -604,  -604,     4,  -604,  -604,   -23,  -604,  -604,   -37,  -604,
    -604,    59,  -604,  -604,    27,  -604,  -603,  -422,  -604,  -275,
    -253,   -82,  -169,  -116,   465,  -604,  -604,  -604,  -133,    22,
    -163,  -303,   -43,  -604,   467,  -604,    -1,  -604,  -486,  -487,
     -49,  -604,  -604,  -604,  -604,  -604,  -113,  -604,   560,  -207,
    -604,   446,  -604,  -604,  -604,  -203,  -604,  -604,  -604,  -604,
     510
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -197
static const yytype_int16 yytable[] =
{
       8,   228,   135,   136,   325,   188,   271,   137,   355,    75,
     230,   310,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    93,   405,   554,   172,   164,   164,   127,   326,   173,
     133,   174,   302,   565,     1,   113,   175,   303,   304,   176,
     177,   133,   133,     7,   306,   389,   196,   138,   178,   671,
      89,   152,    10,   179,   156,   347,     7,     7,   180,   479,
       7,   381,   382,   461,   480,   481,   482,   586,   681,   587,
      94,   215,   143,   144,    90,   120,   504,   505,   151,   487,
     131,   643,   376,   131,   131,   302,   488,   517,    93,    93,
     303,   304,   428,   155,   114,   311,   157,   306,   204,   406,
     407,   388,   510,   408,   606,   128,   409,   128,   229,   370,
     152,     7,   238,   186,   483,   484,   342,   418,   506,   507,
     189,   198,     7,   199,    94,   550,   551,   131,   208,   209,
     210,   211,   212,    95,    96,   563,   438,   645,   646,   647,
     648,   649,   549,   659,    93,    93,    93,    93,    93,   489,
     121,     9,   155,   364,     7,    76,   490,     7,   365,   227,
     106,   222,   226,     7,   602,   603,   604,   605,   256,   257,
     258,   237,   566,   230,   677,   661,    94,   678,   664,   679,
     618,    95,    96,   241,   151,   259,   260,   261,   262,     7,
     251,     7,     7,   112,   506,   507,     7,   271,   254,   118,
     327,   644,   506,   507,   145,   146,   147,   221,   223,    94,
     666,   148,   149,   272,   508,   506,   507,   274,   343,   506,
     507,   119,   526,   662,   663,   665,   667,   668,   207,   669,
       7,    34,   256,   257,   258,   564,   518,   263,   676,   595,
       7,   519,    10,   348,   296,   297,    76,   680,     7,   259,
     260,   261,   262,   683,   340,   684,   685,   686,   227,   687,
     688,    69,   396,   441,    70,   412,   132,    71,     7,     7,
     227,   599,   321,   133,   322,   323,   324,   202,   226,   199,
     226,   131,   417,   470,   614,   145,   146,   147,   227,   140,
     141,   334,   148,   149,   341,    34,   139,   344,   442,   443,
     444,   436,   641,   150,   159,   391,   349,   421,   422,   354,
     296,   419,   164,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   203,   457,   199,   172,   145,
     283,   147,   284,   173,   226,   174,   148,   149,   145,   291,
     175,   292,   185,   176,   177,   148,   149,   296,   191,   390,
     458,   547,   178,   548,   341,   148,   149,   179,   567,   567,
     567,   567,   180,   567,   567,   567,   567,   114,   567,   567,
     495,   567,   567,   567,   232,   233,   501,   502,   503,   543,
     544,   545,   674,   121,   515,   555,   556,   557,   341,   562,
     420,   199,   246,   307,   296,   573,   574,   575,   197,   576,
     577,   578,   579,   598,   580,   581,   600,   582,   583,   584,
     226,   568,   568,   568,   568,   201,   568,   568,   568,   568,
     128,   568,   568,   227,   568,   568,   568,   341,   471,   472,
     473,   381,   382,   205,   615,   206,   598,   491,   492,   493,
     494,   496,   497,   498,   499,   500,   625,   626,   627,   628,
     465,   466,   217,   615,   421,   422,   483,   484,   243,   219,
     509,    70,   670,   220,   231,   131,   234,   235,   236,   245,
     240,   246,   319,   244,   281,   253,   335,   255,   199,   278,
     280,   337,   282,   363,   350,   397,   366,   367,   378,   102,
     103,   104,   105,   368,   107,   108,   109,   110,   111,   369,
     371,   372,   373,   374,   375,   377,   379,   380,   553,   391,
     395,   398,   411,    13,    14,    15,   399,    16,    17,    18,
      19,   400,   401,    20,    21,    22,   402,    23,    24,    25,
      26,    27,   403,    28,   437,   461,   439,  -196,   464,   531,
     478,   520,   114,    29,    30,    31,    32,    33,   521,   522,
     523,   524,   536,   525,   539,   588,   589,   546,   510,    69,
     506,   585,   596,   590,   158,   607,   613,   160,   161,   162,
     163,   619,   167,   168,   169,   170,   171,   617,   620,   622,
     636,    70,   652,   621,   601,   553,   553,   553,   553,   657,
      34,    35,   195,    36,    77,   670,   122,    37,   200,   308,
     394,   553,   469,   194,   252,   423,   624,   404,   345,   416,
     511,   328,   650,   561,   640,   656,   642,   673,   594,   612,
     216,   616,   553,   682,   116,   187,     0,   239,     0,     0,
       0,     0,     0,     0,     0,   651,     0,     0,     0,     0,
       0,     0,   660,     0,   553,   553,   553,   553,   553,     0,
     553,     0,     0,     0,     0,     0,   226,     0,     0,   553,
       0,     0,     0,     0,     0,     0,     0,     0,   553,     0,
       0,     0,     0,     0,   553,     0,   553,   553,   553,     0,
     553,   553,   273,     0,   275,   276,   277,     0,   279,     0,
       0,     0,     0,     0,     0,     0,   285,     0,   286,   287,
     288,   289,   290,     0,     0,     0,     0,     0,   293,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   312,   313,   314,   315,   316,   317,   318,    13,    14,
      15,     0,    16,    17,    18,    19,     0,     0,    20,    21,
      22,     0,    23,    24,    25,    26,    27,     0,    28,     0,
     329,   330,   331,   332,   333,     0,     0,   114,    29,    30,
      31,    32,    33,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   356,   357,   358,
     359,   360,   361,   362,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,   298,    36,     0,
       0,     0,   299,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    13,    14,    15,     0,    16,    17,
      18,    19,     0,     0,    20,    21,    22,     0,    23,    24,
      25,    26,    27,     0,    28,     0,   413,   414,     0,     0,
       0,     0,     0,     0,    29,    30,    31,    32,    33,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   440,     0,
       0,     0,     0,     0,     0,     0,   467,   468,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   474,   475,   476,
     477,    34,    35,     0,    36,    13,    14,    15,    37,    16,
      17,    18,    19,     0,     0,    20,    21,    22,     0,    23,
      24,    25,    26,    27,     0,    28,     0,     0,     0,     0,
       0,     0,   516,     0,     0,    29,    30,    31,    32,    33,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    35,   298,    36,     0,     0,     0,   299
};

static const yytype_int16 yycheck[] =
{
       1,   164,    84,    85,   279,   118,   213,    86,   311,    10,
     165,    10,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,     4,   510,     7,    12,    12,    20,   281,    12,
      21,    14,   247,   519,    87,    36,    19,   247,   247,    22,
      23,    21,    21,    81,   247,   348,   128,    86,    31,   652,
      75,    94,     7,    36,    97,   300,    81,    81,    41,   440,
      81,     8,     9,    11,    33,    34,    35,   554,   671,   555,
      94,    95,    89,    90,    99,    76,   457,   458,   102,    12,
      81,   102,   335,    84,    85,   300,    19,   468,    89,    90,
     300,   300,   395,    94,    41,    94,    97,   300,   137,    81,
      82,   346,    50,    85,   590,    98,    88,    98,    95,    95,
     153,    81,    95,   114,    83,    84,    96,    96,    76,    77,
     121,    96,    81,    98,    94,   506,   507,   128,   145,   146,
     147,   148,   149,   103,   104,   516,   411,   624,   625,   626,
     627,   628,   100,   102,   145,   146,   147,   148,   149,    12,
       6,     0,   153,    96,    81,    11,    19,    81,   101,    81,
      94,   162,   163,    81,   586,   587,   588,   589,    26,    27,
      28,   172,    94,   328,   661,   102,    94,   664,   102,   666,
     602,   103,   104,   184,   102,    43,    44,    45,    46,    81,
     191,    81,    81,    94,    76,    77,    81,   404,   199,    94,
     282,   623,    76,    77,    76,    77,    78,    97,    97,    94,
     102,    83,    84,   214,    96,    76,    77,   218,   297,    76,
      77,    96,    96,   645,   646,   647,   648,   649,   100,   651,
      81,    89,    26,    27,    28,    96,    96,    95,   660,    96,
      81,   101,     7,    94,   245,   246,    11,   669,    81,    43,
      44,    45,    46,   675,    95,   677,   678,   679,    81,   681,
     682,    82,    95,    12,    85,   378,    96,    88,    81,    81,
      81,    94,   273,    21,   275,   276,   277,    96,   279,    98,
     281,   282,    95,    95,    95,    76,    77,    78,    81,    79,
      80,   292,    83,    84,   295,    89,    96,   298,    47,    48,
      49,    95,    95,    94,   102,    37,   307,    39,    40,   310,
     311,   390,    12,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    96,    75,    98,     7,    76,
      94,    78,    96,    12,   335,    14,    83,    84,    76,    96,
      19,    98,    96,    22,    23,    83,    84,   348,     7,   350,
      99,    72,    31,    74,   355,    83,    84,    36,   527,   528,
     529,   530,    41,   532,   533,   534,   535,    41,   537,   538,
     448,   540,   541,   542,    96,    97,   454,   455,   456,    72,
      73,    74,   657,     6,   466,    58,    59,    60,   389,    96,
     391,    98,    31,    32,   395,   528,   529,   530,    96,   532,
     533,   534,   535,   566,   537,   538,   569,   540,   541,   542,
     411,   527,   528,   529,   530,    96,   532,   533,   534,   535,
      98,   537,   538,    81,   540,   541,   542,   428,   429,   430,
     431,     8,     9,    96,   597,    96,   599,   445,   446,   447,
     448,   449,   450,   451,   452,   453,    54,    55,    56,    57,
      96,    97,    97,   616,    39,    40,    83,    84,    15,    97,
     461,    85,    86,    97,    97,   466,    97,    97,    97,    94,
      96,    31,    25,    95,   102,    96,    37,    96,    98,    96,
      96,    25,    97,    94,    36,    97,    96,    96,    94,    24,
      25,    26,    27,    96,    29,    30,    31,    32,    33,    96,
      96,    96,    96,    96,    96,    96,    96,    96,   509,    37,
      94,    97,    38,    12,    13,    14,    97,    16,    17,    18,
      19,    97,    97,    22,    23,    24,    97,    26,    27,    28,
      29,    30,    97,    32,   101,    11,    95,    66,    96,    63,
      96,    96,    41,    42,    43,    44,    45,    46,    96,    96,
      96,    96,    66,    96,    69,   556,   557,    74,    50,    82,
      76,    97,   101,    61,    99,    51,    96,   102,   103,   104,
     105,    96,   107,   108,   109,   110,   111,    97,    96,     3,
      52,    85,    53,    96,   585,   586,   587,   588,   589,    97,
      89,    90,   127,    92,    11,    86,    78,    96,   133,   249,
     352,   602,   424,   125,   192,   392,   607,   363,   300,   384,
     462,   283,   630,   513,   610,   638,   617,   654,   559,   592,
     153,   599,   623,   672,    64,   115,    -1,   181,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   636,    -1,    -1,    -1,    -1,
      -1,    -1,   643,    -1,   645,   646,   647,   648,   649,    -1,
     651,    -1,    -1,    -1,    -1,    -1,   657,    -1,    -1,   660,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   669,    -1,
      -1,    -1,    -1,    -1,   675,    -1,   677,   678,   679,    -1,
     681,   682,   217,    -1,   219,   220,   221,    -1,   223,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   231,    -1,   233,   234,
     235,   236,   237,    -1,    -1,    -1,    -1,    -1,   243,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,    12,    13,
      14,    -1,    16,    17,    18,    19,    -1,    -1,    22,    23,
      24,    -1,    26,    27,    28,    29,    30,    -1,    32,    -1,
     285,   286,   287,   288,   289,    -1,    -1,    41,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,   313,   314,
     315,   316,   317,   318,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    16,    17,
      18,    19,    -1,    -1,    22,    23,    24,    -1,    26,    27,
      28,    29,    30,    -1,    32,    -1,   381,   382,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    43,    44,    45,    46,    -1,
      -1,    -1,   397,   398,   399,   400,   401,   402,   403,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   413,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   421,   422,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   432,   433,   434,
     435,    89,    90,    -1,    92,    12,    13,    14,    96,    16,
      17,    18,    19,    -1,    -1,    22,    23,    24,    -1,    26,
      27,    28,    29,    30,    -1,    32,    -1,    -1,    -1,    -1,
      -1,    -1,   467,    -1,    -1,    42,    43,    44,    45,    46,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,    96
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    87,   106,   107,   108,   258,   259,    81,   251,     0,
       7,   111,   112,    12,    13,    14,    16,    17,    18,    19,
      22,    23,    24,    26,    27,    28,    29,    30,    32,    42,
      43,    44,    45,    46,    89,    90,    92,    96,   138,   139,
     140,   141,   142,   143,   144,   146,   148,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   176,   257,   261,   262,   263,   264,   270,   273,    82,
      85,    88,   231,   254,   260,   251,    11,   112,   113,   114,
     251,   251,   251,   251,   251,   251,   251,   251,   251,    75,
      99,   150,   151,   251,    94,   103,   104,   237,   238,   239,
     247,   251,   239,   239,   239,   239,    94,   239,   239,   239,
     239,   239,    94,   251,    41,   200,   263,   275,    94,    96,
     251,     6,   114,   115,   116,   117,   118,    20,    98,   145,
     236,   251,    96,    21,   125,   236,   236,   125,   145,    96,
      79,    80,   147,   150,   150,    76,    77,    78,    83,    84,
      94,   102,   247,   248,   249,   251,   247,   251,   239,   102,
     239,   239,   239,   239,    12,   174,   175,   239,   239,   239,
     239,   239,     7,    12,    14,    19,    22,    23,    31,    36,
      41,   265,   266,   267,   268,    96,   251,   275,   261,   251,
     109,     7,   119,   120,   118,   239,   236,    96,    96,    98,
     239,    96,    96,    96,   145,    96,    96,   100,   150,   150,
     150,   150,   150,   152,   250,    95,   249,    97,   240,    97,
      97,    97,   251,    97,   234,   235,   251,    81,   245,    95,
     175,    97,    96,    97,    97,    97,    97,   251,    95,   266,
      96,   251,   269,    15,    95,    94,    31,   121,   122,   123,
     124,   251,   120,    96,   251,    96,    26,    27,    28,    43,
      44,    45,    46,    95,   153,   154,   155,   156,   157,   158,
     159,   264,   251,   239,   251,   239,   239,   239,    96,   239,
      96,   102,    97,    94,    96,   239,   239,   239,   239,   239,
     239,    96,    98,   239,   271,   246,   251,   251,    91,    96,
     136,   137,   138,   139,   148,   256,   270,    32,   124,   126,
      10,    94,   239,   239,   239,   239,   239,   239,   239,    25,
     149,   251,   251,   251,   251,   234,   235,   236,   174,   239,
     239,   239,   239,   239,   251,    37,   201,    25,   272,   274,
      95,   251,    96,   125,   251,   137,   199,   200,    94,   251,
      36,   127,   128,   129,   251,   246,   239,   239,   239,   239,
     239,   239,   239,    94,    96,   101,    96,    96,    96,    96,
      95,    96,    96,    96,    96,    96,   235,    96,    94,    96,
      96,     8,     9,   177,   178,   179,   180,   181,   200,   246,
     251,    37,   130,   131,   129,    94,    95,    97,    97,    97,
      97,    97,    97,    97,   152,     4,    81,    82,    85,    88,
     253,    38,   261,   239,   239,   110,   179,    95,    96,   125,
     251,    39,    40,   131,   132,   133,   134,   135,   246,   239,
     239,   239,   239,   239,   239,   239,    95,   101,   234,    95,
     239,    12,    47,    48,    49,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    75,    99,   182,
     183,    11,   202,   203,    96,    96,    97,   239,   239,   133,
      95,   251,   251,   251,   239,   239,   239,   239,    96,   182,
      33,    34,    35,    83,    84,   197,   198,    12,    19,    12,
      19,   197,   197,   197,   197,   198,   197,   197,   197,   197,
     197,   198,   198,   198,   182,   182,    76,    77,    96,   251,
      50,   203,   211,   212,   213,   236,   239,   182,    96,   101,
      96,    96,    96,    96,    96,    96,    96,   193,   195,   194,
     196,    63,   184,   185,   186,   187,    66,   188,   189,    69,
     190,   191,   192,    72,    73,    74,    74,    72,    74,   100,
     182,   182,   232,   251,   254,    58,    59,    60,   224,   225,
     226,   213,    96,   182,    96,   253,    94,   237,   238,   241,
     242,   243,   245,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,    97,   254,   253,   251,   251,
      61,   227,   228,   229,   226,    96,   101,   244,   245,    94,
     245,   251,   232,   232,   232,   232,   253,    51,   214,   215,
     216,   217,   229,    96,    95,   245,   244,    97,   232,    96,
      96,    96,     3,   252,   251,    54,    55,    56,    57,   204,
     205,   206,   207,   208,   209,   210,    52,   218,   219,   220,
     217,    95,   251,   102,   232,   254,   254,   254,   254,   254,
     206,   251,    53,   221,   222,   223,   220,    97,   233,   102,
     251,   102,   232,   232,   102,   232,   102,   232,   232,   232,
      86,   231,   255,   223,   234,   230,   232,   254,   254,   254,
     232,   231,   255,   232,   232,   232,   232,   232,   232
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:

/* Line 1464 of yacc.c  */
#line 155 "policy_parse.y"
    { if (define_policy(pass, 0) == -1) return -1; }
    break;

  case 5:

/* Line 1464 of yacc.c  */
#line 157 "policy_parse.y"
    { if (pass == 1) { if (policydb_index_classes(policydbp)) return -1; }
                            else if (pass == 2) { if (policydb_index_others(NULL, policydbp, 0)) return -1; }}
    break;

  case 6:

/* Line 1464 of yacc.c  */
#line 160 "policy_parse.y"
    { if (pass == 1) { if (policydb_index_bools(policydbp)) return -1;}
			   else if (pass == 2) { if (policydb_index_others(NULL, policydbp, 0)) return -1;}}
    break;

  case 10:

/* Line 1464 of yacc.c  */
#line 168 "policy_parse.y"
    {if (define_class()) return -1;}
    break;

  case 13:

/* Line 1464 of yacc.c  */
#line 174 "policy_parse.y"
    {if (define_initial_sid()) return -1;}
    break;

  case 19:

/* Line 1464 of yacc.c  */
#line 185 "policy_parse.y"
    {if (define_common_perms()) return -1;}
    break;

  case 22:

/* Line 1464 of yacc.c  */
#line 191 "policy_parse.y"
    {if (define_av_perms(FALSE)) return -1;}
    break;

  case 23:

/* Line 1464 of yacc.c  */
#line 193 "policy_parse.y"
    {if (define_av_perms(TRUE)) return -1;}
    break;

  case 24:

/* Line 1464 of yacc.c  */
#line 195 "policy_parse.y"
    {if (define_av_perms(TRUE)) return -1;}
    break;

  case 30:

/* Line 1464 of yacc.c  */
#line 206 "policy_parse.y"
    {if (define_sens()) return -1;}
    break;

  case 31:

/* Line 1464 of yacc.c  */
#line 208 "policy_parse.y"
    {if (define_sens()) return -1;}
    break;

  case 33:

/* Line 1464 of yacc.c  */
#line 213 "policy_parse.y"
    {if (define_dominance()) return -1;}
    break;

  case 34:

/* Line 1464 of yacc.c  */
#line 215 "policy_parse.y"
    {if (define_dominance()) return -1;}
    break;

  case 39:

/* Line 1464 of yacc.c  */
#line 224 "policy_parse.y"
    {if (define_category()) return -1;}
    break;

  case 40:

/* Line 1464 of yacc.c  */
#line 226 "policy_parse.y"
    {if (define_category()) return -1;}
    break;

  case 43:

/* Line 1464 of yacc.c  */
#line 232 "policy_parse.y"
    {if (define_level()) return -1;}
    break;

  case 44:

/* Line 1464 of yacc.c  */
#line 234 "policy_parse.y"
    {if (define_level()) return -1;}
    break;

  case 49:

/* Line 1464 of yacc.c  */
#line 243 "policy_parse.y"
    { if (define_constraint((constraint_expr_t*)(yyvsp[(4) - (5)].valptr))) return -1; }
    break;

  case 50:

/* Line 1464 of yacc.c  */
#line 246 "policy_parse.y"
    { if (define_validatetrans((constraint_expr_t*)(yyvsp[(3) - (4)].valptr))) return -1; }
    break;

  case 76:

/* Line 1464 of yacc.c  */
#line 278 "policy_parse.y"
    { if (define_attrib()) return -1;}
    break;

  case 77:

/* Line 1464 of yacc.c  */
#line 281 "policy_parse.y"
    {if (define_type(1)) return -1;}
    break;

  case 78:

/* Line 1464 of yacc.c  */
#line 283 "policy_parse.y"
    {if (define_type(0)) return -1;}
    break;

  case 79:

/* Line 1464 of yacc.c  */
#line 286 "policy_parse.y"
    {if (define_typealias()) return -1;}
    break;

  case 80:

/* Line 1464 of yacc.c  */
#line 289 "policy_parse.y"
    {if (define_typeattribute()) return -1;}
    break;

  case 81:

/* Line 1464 of yacc.c  */
#line 292 "policy_parse.y"
    {if (define_typebounds()) return -1;}
    break;

  case 84:

/* Line 1464 of yacc.c  */
#line 298 "policy_parse.y"
    {if (define_bool()) return -1;}
    break;

  case 85:

/* Line 1464 of yacc.c  */
#line 301 "policy_parse.y"
    { if (insert_id("T",0)) return -1; }
    break;

  case 86:

/* Line 1464 of yacc.c  */
#line 303 "policy_parse.y"
    { if (insert_id("F",0)) return -1; }
    break;

  case 87:

/* Line 1464 of yacc.c  */
#line 306 "policy_parse.y"
    { if (pass == 2) { if (define_conditional((cond_expr_t*)(yyvsp[(2) - (6)].ptr), (avrule_t*)(yyvsp[(4) - (6)].ptr), (avrule_t*)(yyvsp[(6) - (6)].ptr)) < 0) return -1;  }}
    break;

  case 88:

/* Line 1464 of yacc.c  */
#line 309 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(3) - (4)].ptr); }
    break;

  case 89:

/* Line 1464 of yacc.c  */
#line 311 "policy_parse.y"
    { (yyval.ptr) = NULL; }
    break;

  case 90:

/* Line 1464 of yacc.c  */
#line 313 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(2) - (3)].ptr);}
    break;

  case 91:

/* Line 1464 of yacc.c  */
#line 315 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_NOT, (yyvsp[(2) - (2)].ptr), 0);
			  if ((yyval.ptr) == 0) return -1; }
    break;

  case 92:

/* Line 1464 of yacc.c  */
#line 318 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_AND, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 93:

/* Line 1464 of yacc.c  */
#line 321 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_OR, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return   -1; }
    break;

  case 94:

/* Line 1464 of yacc.c  */
#line 324 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_XOR, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 95:

/* Line 1464 of yacc.c  */
#line 327 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_EQ, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 96:

/* Line 1464 of yacc.c  */
#line 330 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_NEQ, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 97:

/* Line 1464 of yacc.c  */
#line 333 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 98:

/* Line 1464 of yacc.c  */
#line 336 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_BOOL,0, 0);
			  if ((yyval.ptr) == COND_ERR) return   -1; }
    break;

  case 99:

/* Line 1464 of yacc.c  */
#line 340 "policy_parse.y"
    { (yyval.ptr) = define_cond_pol_list((avrule_t *)(yyvsp[(1) - (2)].ptr), (avrule_t *)(yyvsp[(2) - (2)].ptr)); }
    break;

  case 100:

/* Line 1464 of yacc.c  */
#line 342 "policy_parse.y"
    { (yyval.ptr) = NULL; }
    break;

  case 101:

/* Line 1464 of yacc.c  */
#line 345 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 102:

/* Line 1464 of yacc.c  */
#line 347 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 103:

/* Line 1464 of yacc.c  */
#line 349 "policy_parse.y"
    { (yyval.ptr) = NULL; }
    break;

  case 104:

/* Line 1464 of yacc.c  */
#line 352 "policy_parse.y"
    { (yyval.ptr) = define_cond_filename_trans() ;
                          if ((yyval.ptr) == COND_ERR) return -1;}
    break;

  case 105:

/* Line 1464 of yacc.c  */
#line 355 "policy_parse.y"
    { (yyval.ptr) = define_cond_compute_type(AVRULE_TRANSITION) ;
                          if ((yyval.ptr) == COND_ERR) return -1;}
    break;

  case 106:

/* Line 1464 of yacc.c  */
#line 358 "policy_parse.y"
    { (yyval.ptr) = define_cond_compute_type(AVRULE_MEMBER) ;
                          if ((yyval.ptr) ==  COND_ERR) return -1;}
    break;

  case 107:

/* Line 1464 of yacc.c  */
#line 361 "policy_parse.y"
    { (yyval.ptr) = define_cond_compute_type(AVRULE_CHANGE) ;
                          if ((yyval.ptr) == COND_ERR) return -1;}
    break;

  case 108:

/* Line 1464 of yacc.c  */
#line 365 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 109:

/* Line 1464 of yacc.c  */
#line 367 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 110:

/* Line 1464 of yacc.c  */
#line 369 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 111:

/* Line 1464 of yacc.c  */
#line 371 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 112:

/* Line 1464 of yacc.c  */
#line 374 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_ALLOWED) ;
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 113:

/* Line 1464 of yacc.c  */
#line 378 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_AUDITALLOW) ;
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 114:

/* Line 1464 of yacc.c  */
#line 382 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_AUDITDENY) ;
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 115:

/* Line 1464 of yacc.c  */
#line 386 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_DONTAUDIT);
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 116:

/* Line 1464 of yacc.c  */
#line 390 "policy_parse.y"
    {if (define_filename_trans()) return -1; }
    break;

  case 117:

/* Line 1464 of yacc.c  */
#line 392 "policy_parse.y"
    {if (define_compute_type(AVRULE_TRANSITION)) return -1;}
    break;

  case 118:

/* Line 1464 of yacc.c  */
#line 394 "policy_parse.y"
    {if (define_compute_type(AVRULE_MEMBER)) return -1;}
    break;

  case 119:

/* Line 1464 of yacc.c  */
#line 396 "policy_parse.y"
    {if (define_compute_type(AVRULE_CHANGE)) return -1;}
    break;

  case 120:

/* Line 1464 of yacc.c  */
#line 399 "policy_parse.y"
    { if (define_range_trans(0)) return -1; }
    break;

  case 121:

/* Line 1464 of yacc.c  */
#line 401 "policy_parse.y"
    { if (define_range_trans(1)) return -1; }
    break;

  case 127:

/* Line 1464 of yacc.c  */
#line 410 "policy_parse.y"
    {if (define_te_avtab(AVRULE_ALLOWED)) return -1; }
    break;

  case 128:

/* Line 1464 of yacc.c  */
#line 413 "policy_parse.y"
    {if (define_te_avtab(AVRULE_AUDITALLOW)) return -1; }
    break;

  case 129:

/* Line 1464 of yacc.c  */
#line 416 "policy_parse.y"
    {if (define_te_avtab(AVRULE_AUDITDENY)) return -1; }
    break;

  case 130:

/* Line 1464 of yacc.c  */
#line 419 "policy_parse.y"
    {if (define_te_avtab(AVRULE_DONTAUDIT)) return -1; }
    break;

  case 131:

/* Line 1464 of yacc.c  */
#line 422 "policy_parse.y"
    {if (define_te_avtab(AVRULE_NEVERALLOW)) return -1; }
    break;

  case 132:

/* Line 1464 of yacc.c  */
#line 425 "policy_parse.y"
    {if (define_attrib_role()) return -1; }
    break;

  case 133:

/* Line 1464 of yacc.c  */
#line 428 "policy_parse.y"
    {if (define_role_types()) return -1;}
    break;

  case 134:

/* Line 1464 of yacc.c  */
#line 431 "policy_parse.y"
    {if (define_role_attr()) return -1;}
    break;

  case 136:

/* Line 1464 of yacc.c  */
#line 436 "policy_parse.y"
    {if (define_role_trans(0)) return -1; }
    break;

  case 137:

/* Line 1464 of yacc.c  */
#line 438 "policy_parse.y"
    {if (define_role_trans(1)) return -1;}
    break;

  case 138:

/* Line 1464 of yacc.c  */
#line 441 "policy_parse.y"
    {if (define_role_allow()) return -1; }
    break;

  case 139:

/* Line 1464 of yacc.c  */
#line 444 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 140:

/* Line 1464 of yacc.c  */
#line 446 "policy_parse.y"
    { (yyval.ptr) = merge_roles_dom((role_datum_t*)(yyvsp[(1) - (2)].ptr), (role_datum_t*)(yyvsp[(2) - (2)].ptr)); if ((yyval.ptr) == 0) return -1;}
    break;

  case 141:

/* Line 1464 of yacc.c  */
#line 449 "policy_parse.y"
    {(yyval.ptr) = define_role_dom(NULL); if ((yyval.ptr) == 0) return -1;}
    break;

  case 142:

/* Line 1464 of yacc.c  */
#line 451 "policy_parse.y"
    {(yyval.ptr) = define_role_dom((role_datum_t*)(yyvsp[(4) - (5)].ptr)); if ((yyval.ptr) == 0) return -1;}
    break;

  case 143:

/* Line 1464 of yacc.c  */
#line 454 "policy_parse.y"
    {if (define_roleattribute()) return -1;}
    break;

  case 150:

/* Line 1464 of yacc.c  */
#line 466 "policy_parse.y"
    { if (define_constraint((constraint_expr_t*)(yyvsp[(4) - (5)].valptr))) return -1; }
    break;

  case 151:

/* Line 1464 of yacc.c  */
#line 469 "policy_parse.y"
    { if (define_validatetrans((constraint_expr_t*)(yyvsp[(3) - (4)].valptr))) return -1; }
    break;

  case 152:

/* Line 1464 of yacc.c  */
#line 472 "policy_parse.y"
    { (yyval.valptr) = (yyvsp[(2) - (3)].valptr); }
    break;

  case 153:

/* Line 1464 of yacc.c  */
#line 474 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NOT, (yyvsp[(2) - (2)].valptr), 0);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 154:

/* Line 1464 of yacc.c  */
#line 477 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_AND, (yyvsp[(1) - (3)].valptr), (yyvsp[(3) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 155:

/* Line 1464 of yacc.c  */
#line 480 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_OR, (yyvsp[(1) - (3)].valptr), (yyvsp[(3) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 156:

/* Line 1464 of yacc.c  */
#line 483 "policy_parse.y"
    { (yyval.valptr) = (yyvsp[(1) - (1)].valptr); }
    break;

  case 157:

/* Line 1464 of yacc.c  */
#line 486 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_USER, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 158:

/* Line 1464 of yacc.c  */
#line 489 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 159:

/* Line 1464 of yacc.c  */
#line 492 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_TYPE, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 160:

/* Line 1464 of yacc.c  */
#line 494 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 161:

/* Line 1464 of yacc.c  */
#line 495 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_USER, (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 162:

/* Line 1464 of yacc.c  */
#line 497 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 163:

/* Line 1464 of yacc.c  */
#line 498 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_TARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 164:

/* Line 1464 of yacc.c  */
#line 500 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 165:

/* Line 1464 of yacc.c  */
#line 501 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_XTARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 166:

/* Line 1464 of yacc.c  */
#line 503 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 167:

/* Line 1464 of yacc.c  */
#line 504 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 168:

/* Line 1464 of yacc.c  */
#line 506 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 169:

/* Line 1464 of yacc.c  */
#line 507 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 170:

/* Line 1464 of yacc.c  */
#line 509 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 171:

/* Line 1464 of yacc.c  */
#line 510 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_XTARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 172:

/* Line 1464 of yacc.c  */
#line 512 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 173:

/* Line 1464 of yacc.c  */
#line 513 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 174:

/* Line 1464 of yacc.c  */
#line 515 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 175:

/* Line 1464 of yacc.c  */
#line 516 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 176:

/* Line 1464 of yacc.c  */
#line 518 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 177:

/* Line 1464 of yacc.c  */
#line 519 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_XTARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 178:

/* Line 1464 of yacc.c  */
#line 522 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_USER, CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 179:

/* Line 1464 of yacc.c  */
#line 524 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 180:

/* Line 1464 of yacc.c  */
#line 525 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 181:

/* Line 1464 of yacc.c  */
#line 527 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 182:

/* Line 1464 of yacc.c  */
#line 528 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 183:

/* Line 1464 of yacc.c  */
#line 531 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, (yyvsp[(2) - (2)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 184:

/* Line 1464 of yacc.c  */
#line 533 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 185:

/* Line 1464 of yacc.c  */
#line 534 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 186:

/* Line 1464 of yacc.c  */
#line 536 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 187:

/* Line 1464 of yacc.c  */
#line 537 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 188:

/* Line 1464 of yacc.c  */
#line 540 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L1L2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 189:

/* Line 1464 of yacc.c  */
#line 543 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L1H2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 190:

/* Line 1464 of yacc.c  */
#line 546 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_H1L2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 191:

/* Line 1464 of yacc.c  */
#line 549 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_H1H2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 192:

/* Line 1464 of yacc.c  */
#line 552 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L1H1, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 193:

/* Line 1464 of yacc.c  */
#line 555 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L2H2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 194:

/* Line 1464 of yacc.c  */
#line 559 "policy_parse.y"
    { (yyval.valptr) = CEXPR_EQ; }
    break;

  case 195:

/* Line 1464 of yacc.c  */
#line 561 "policy_parse.y"
    { (yyval.valptr) = CEXPR_NEQ; }
    break;

  case 196:

/* Line 1464 of yacc.c  */
#line 564 "policy_parse.y"
    { (yyval.valptr) = (yyvsp[(1) - (1)].valptr); }
    break;

  case 197:

/* Line 1464 of yacc.c  */
#line 566 "policy_parse.y"
    { (yyval.valptr) = CEXPR_DOM; }
    break;

  case 198:

/* Line 1464 of yacc.c  */
#line 568 "policy_parse.y"
    { (yyval.valptr) = CEXPR_DOMBY; }
    break;

  case 199:

/* Line 1464 of yacc.c  */
#line 570 "policy_parse.y"
    { (yyval.valptr) = CEXPR_INCOMP; }
    break;

  case 202:

/* Line 1464 of yacc.c  */
#line 576 "policy_parse.y"
    {if (define_user()) return -1;}
    break;

  case 207:

/* Line 1464 of yacc.c  */
#line 585 "policy_parse.y"
    {if (define_initial_sid_context()) return -1;}
    break;

  case 216:

/* Line 1464 of yacc.c  */
#line 598 "policy_parse.y"
    {if (define_pirq_context((yyvsp[(2) - (3)].val))) return -1;}
    break;

  case 217:

/* Line 1464 of yacc.c  */
#line 601 "policy_parse.y"
    {if (define_iomem_context((yyvsp[(2) - (3)].val),(yyvsp[(2) - (3)].val))) return -1;}
    break;

  case 218:

/* Line 1464 of yacc.c  */
#line 603 "policy_parse.y"
    {if (define_iomem_context((yyvsp[(2) - (5)].val),(yyvsp[(4) - (5)].val))) return -1;}
    break;

  case 219:

/* Line 1464 of yacc.c  */
#line 606 "policy_parse.y"
    {if (define_ioport_context((yyvsp[(2) - (3)].val),(yyvsp[(2) - (3)].val))) return -1;}
    break;

  case 220:

/* Line 1464 of yacc.c  */
#line 608 "policy_parse.y"
    {if (define_ioport_context((yyvsp[(2) - (5)].val),(yyvsp[(4) - (5)].val))) return -1;}
    break;

  case 221:

/* Line 1464 of yacc.c  */
#line 611 "policy_parse.y"
    {if (define_pcidevice_context((yyvsp[(2) - (3)].val))) return -1;}
    break;

  case 226:

/* Line 1464 of yacc.c  */
#line 620 "policy_parse.y"
    {if (define_fs_context((yyvsp[(2) - (5)].val),(yyvsp[(3) - (5)].val))) return -1;}
    break;

  case 232:

/* Line 1464 of yacc.c  */
#line 631 "policy_parse.y"
    {if (define_port_context((yyvsp[(3) - (4)].val),(yyvsp[(3) - (4)].val))) return -1;}
    break;

  case 233:

/* Line 1464 of yacc.c  */
#line 633 "policy_parse.y"
    {if (define_port_context((yyvsp[(3) - (6)].val),(yyvsp[(5) - (6)].val))) return -1;}
    break;

  case 238:

/* Line 1464 of yacc.c  */
#line 642 "policy_parse.y"
    {if (define_netif_context()) return -1;}
    break;

  case 243:

/* Line 1464 of yacc.c  */
#line 651 "policy_parse.y"
    {if (define_ipv4_node_context()) return -1;}
    break;

  case 244:

/* Line 1464 of yacc.c  */
#line 653 "policy_parse.y"
    {if (define_ipv6_node_context()) return -1;}
    break;

  case 249:

/* Line 1464 of yacc.c  */
#line 662 "policy_parse.y"
    {if (define_fs_use(SECURITY_FS_USE_XATTR)) return -1;}
    break;

  case 250:

/* Line 1464 of yacc.c  */
#line 664 "policy_parse.y"
    {if (define_fs_use(SECURITY_FS_USE_TASK)) return -1;}
    break;

  case 251:

/* Line 1464 of yacc.c  */
#line 666 "policy_parse.y"
    {if (define_fs_use(SECURITY_FS_USE_TRANS)) return -1;}
    break;

  case 256:

/* Line 1464 of yacc.c  */
#line 675 "policy_parse.y"
    {if (define_genfs_context(1)) return -1;}
    break;

  case 257:

/* Line 1464 of yacc.c  */
#line 676 "policy_parse.y"
    {insert_id("-", 0);}
    break;

  case 258:

/* Line 1464 of yacc.c  */
#line 677 "policy_parse.y"
    {if (define_genfs_context(1)) return -1;}
    break;

  case 259:

/* Line 1464 of yacc.c  */
#line 679 "policy_parse.y"
    {if (define_genfs_context(0)) return -1;}
    break;

  case 260:

/* Line 1464 of yacc.c  */
#line 682 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 264:

/* Line 1464 of yacc.c  */
#line 690 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 265:

/* Line 1464 of yacc.c  */
#line 692 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 266:

/* Line 1464 of yacc.c  */
#line 695 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 267:

/* Line 1464 of yacc.c  */
#line 697 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 272:

/* Line 1464 of yacc.c  */
#line 707 "policy_parse.y"
    { if (insert_separator(0)) return -1; }
    break;

  case 273:

/* Line 1464 of yacc.c  */
#line 709 "policy_parse.y"
    { if (insert_separator(0)) return -1; }
    break;

  case 274:

/* Line 1464 of yacc.c  */
#line 711 "policy_parse.y"
    { if (insert_id("*", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
    break;

  case 275:

/* Line 1464 of yacc.c  */
#line 714 "policy_parse.y"
    { if (insert_id("~", 0)) return -1;
			  if (insert_separator(0)) return -1; }
    break;

  case 276:

/* Line 1464 of yacc.c  */
#line 717 "policy_parse.y"
    { if (insert_id("~", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
    break;

  case 277:

/* Line 1464 of yacc.c  */
#line 719 "policy_parse.y"
    { if (insert_id("-", 0)) return -1; }
    break;

  case 278:

/* Line 1464 of yacc.c  */
#line 720 "policy_parse.y"
    { if (insert_separator(0)) return -1; }
    break;

  case 279:

/* Line 1464 of yacc.c  */
#line 723 "policy_parse.y"
    { if (insert_id("~", 1)) return -1; }
    break;

  case 280:

/* Line 1464 of yacc.c  */
#line 726 "policy_parse.y"
    { if (insert_id("*", 1)) return -1; }
    break;

  case 288:

/* Line 1464 of yacc.c  */
#line 738 "policy_parse.y"
    { if (insert_id(yytext, 1)) return -1; }
    break;

  case 295:

/* Line 1464 of yacc.c  */
#line 747 "policy_parse.y"
    { if (insert_id("-", 0)) return -1; }
    break;

  case 298:

/* Line 1464 of yacc.c  */
#line 750 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 299:

/* Line 1464 of yacc.c  */
#line 753 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 300:

/* Line 1464 of yacc.c  */
#line 756 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 301:

/* Line 1464 of yacc.c  */
#line 758 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 302:

/* Line 1464 of yacc.c  */
#line 760 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 303:

/* Line 1464 of yacc.c  */
#line 762 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 304:

/* Line 1464 of yacc.c  */
#line 764 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 305:

/* Line 1464 of yacc.c  */
#line 767 "policy_parse.y"
    { (yyval.val) = strtoul(yytext,NULL,0); }
    break;

  case 306:

/* Line 1464 of yacc.c  */
#line 770 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 307:

/* Line 1464 of yacc.c  */
#line 773 "policy_parse.y"
    {if (define_polcap()) return -1;}
    break;

  case 308:

/* Line 1464 of yacc.c  */
#line 776 "policy_parse.y"
    {if (define_permissive()) return -1;}
    break;

  case 309:

/* Line 1464 of yacc.c  */
#line 781 "policy_parse.y"
    { if (end_avrule_block(pass) == -1) return -1;
                          if (policydb_index_others(NULL, policydbp, 0)) return -1;
                        }
    break;

  case 310:

/* Line 1464 of yacc.c  */
#line 786 "policy_parse.y"
    { if (define_policy(pass, 1) == -1) return -1; }
    break;

  case 311:

/* Line 1464 of yacc.c  */
#line 789 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 312:

/* Line 1464 of yacc.c  */
#line 791 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 328:

/* Line 1464 of yacc.c  */
#line 815 "policy_parse.y"
    { if (require_class(pass)) return -1; }
    break;

  case 329:

/* Line 1464 of yacc.c  */
#line 817 "policy_parse.y"
    { (yyval.require_func) = require_role; }
    break;

  case 330:

/* Line 1464 of yacc.c  */
#line 818 "policy_parse.y"
    { (yyval.require_func) = require_type; }
    break;

  case 331:

/* Line 1464 of yacc.c  */
#line 819 "policy_parse.y"
    { (yyval.require_func) = require_attribute; }
    break;

  case 332:

/* Line 1464 of yacc.c  */
#line 820 "policy_parse.y"
    { (yyval.require_func) = require_attribute_role; }
    break;

  case 333:

/* Line 1464 of yacc.c  */
#line 821 "policy_parse.y"
    { (yyval.require_func) = require_user; }
    break;

  case 334:

/* Line 1464 of yacc.c  */
#line 822 "policy_parse.y"
    { (yyval.require_func) = require_bool; }
    break;

  case 335:

/* Line 1464 of yacc.c  */
#line 823 "policy_parse.y"
    { (yyval.require_func) = require_sens; }
    break;

  case 336:

/* Line 1464 of yacc.c  */
#line 824 "policy_parse.y"
    { (yyval.require_func) = require_cat; }
    break;

  case 337:

/* Line 1464 of yacc.c  */
#line 827 "policy_parse.y"
    { if ((yyvsp[(0) - (1)].require_func) (pass)) return -1; }
    break;

  case 338:

/* Line 1464 of yacc.c  */
#line 829 "policy_parse.y"
    { if ((yyvsp[(0) - (3)].require_func) (pass)) return -1; }
    break;

  case 339:

/* Line 1464 of yacc.c  */
#line 832 "policy_parse.y"
    { if (end_avrule_block(pass) == -1) return -1; }
    break;

  case 340:

/* Line 1464 of yacc.c  */
#line 834 "policy_parse.y"
    { if (end_optional(pass) == -1) return -1; }
    break;

  case 341:

/* Line 1464 of yacc.c  */
#line 837 "policy_parse.y"
    { if (end_avrule_block(pass) == -1) return -1; }
    break;

  case 343:

/* Line 1464 of yacc.c  */
#line 841 "policy_parse.y"
    { if (begin_optional(pass) == -1) return -1; }
    break;

  case 344:

/* Line 1464 of yacc.c  */
#line 844 "policy_parse.y"
    { if (begin_optional_else(pass) == -1) return -1; }
    break;



/* Line 1464 of yacc.c  */
#line 3725 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



